routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::redirect('/', '/home');

Route::resource('products', 'ProductsController');
Route::resource('categories', 'CategoriesController');
Route::resource('brands', 'BrandsController');
Route::resource('orders', 'OrdersController');
Route::get('chats/message/{to_user_id}', 'ChatsController@message')->name('chats.message');
Route::resource('chats', 'ChatsController');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    public function user(){
        return $this->belongsTo('App\User');
    }

    public function category(){
        return $this->belongsTo('App\Category');
    }

    public function brand(){
        return $this->belongsTo('App\Brand');
    }

    public function orders(){
        return $this->hasMany('App\Order');
    }
}

app/Http/Controllers/ProductsController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Product;
use App\User;
use App\Brand;
use App\Category;

class ProductsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $sort)
    {
        $products = Product::orderBy('price', 'asc')->paginate(9);
        $brands = Brand::orderBy('name', 'asc')->get();
        $brand = ['name' => ''];
        if (!auth()->user() == null && auth()->user()->role == 'seller') {
            $user_id = auth()->user()->id;
            $brands = Brand::where('user_id', $user_id)->orderBy('name', 'asc')->get();
            $products = Product::where('user_id', $user_id)->orderBy('price', 'desc')->paginate(9);
            if (!$sort->price_from == null && !$sort->price_to == null && !$sort->sort_brand == null) {
                $brand = Brand::select('id', 'name')->where('id', $sort->sort_brand)->first();
                $products = Product::where('user_id', $user_id)
                    ->where('price', '>=', $sort->price_from)
                    ->where('price', '<=', $sort->price_to)
                    ->where('brand_id', $sort->sort_brand)
                    ->orderBy('price', 'desc')->paginate(9);
            } elseif (!$sort->price_from == null && !$sort->price_to == null) {
                $products = Product::where('user_id', $user_id)
                    ->where('price', '>=', $sort->price_from)
                    ->where('price', '<=', $sort->price_to)
                    ->orderBy('price', 'desc')->paginate(9);
            } elseif (!$sort->sort_brand == null) {
                $brand = Brand::select('id', 'name')->where('id', $sort->sort_brand)->first();
                $products = Product::where('user_id', $user_id)
                    ->where('brand_id', $sort->sort_brand)
                    ->orderBy('price', 'desc')->paginate(9);
            }
        } elseif (!$sort->price_from == null && !$sort->price_to == null && !$sort->sort_brand == null) {
            $brand = Brand::select('id', 'name')->where('id', $sort->sort_brand)->first();
            $products = Product::where('price', '>=', $sort->price_from)
                ->where('price', '<=', $sort->price_to)
                ->where('brand_id', $sort->sort_brand)
                ->orderBy('price', 'desc')->paginate(9);
        } elseif (!$sort->price_from == null && !$sort->price_to == null) {
            $products = Product::where('price', '>=', $sort->price_from)
                ->where('price', '<=', $sort->price_to)
                ->orderBy('price', 'desc')->paginate(9);
        } elseif (!$sort->sort_brand == null) {
            $brand = Brand::select('id', 'name')->where('id', $sort->sort_brand)->first();
            $products = Product::where('brand_id', $sort->sort_brand)
                ->orderBy('price', 'desc')->paginate(9);
        }
        return view('products.index')
            ->with('products', $products)
            ->with('price_from', $sort->price_from)
            ->with('price_to', $sort->price_to)
            ->with('brand', $brand)
            ->with('brands', $brands);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if (!auth()->user() == null && auth()->user()->role == 'seller') {
            $user_id = auth()->user()->id;
            $brands = Brand::where('user_id', $user_id)
                ->orderBy('name', 'asc')->get();
            $categories = Category::where('user_id', $user_id)
                ->orderBy('name', 'asc')->get();
            return view('products.create')
                ->with('brands', $brands)
                ->with('categories', $categories);
        }
        return redirect()->route('products.index');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required',
            'description' => 'required',
            'price' => 'required',
            'stock' => 'required',
            'category' => 'required',
            'brand' => 'required'
        ]);

        $product = new Product;
        $product->user_id = auth()->user()->id;
        $product->name = $request->name;
        $product->description = $request->description;
        $product->price = $request->price;
        $product->stock = $request->stock;
        $product->category_id = $request->category;
        $product->brand_id = $request->brand;
        $product->save();
        return redirect()->route('products.index')
            ->with('success', 'Product ' . $product->name . ' Successfully Added');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $product = Product::find($id);
        return view('products.show')->with('product', $product);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $product = Product::find($id);
        if (!auth()->user() == null && (auth()->user()->id == $product->user->id && auth()->user()->role == 'seller')) {
            $user_id = auth()->user()->id;
            $brands = Brand::where('user_id', $user_id)
                ->orderBy('name', 'asc')->get();
            $categories = Category::where('user_id', $user_id)
                ->orderBy('name', 'asc')->get();
            return view('products.edit')
                ->with('product', $product)
                ->with('brands', $brands)
                ->with('categories', $categories);
        }
        return redirect()->route('products.index');
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'description' => 'required',
            'price' => 'required',
            'stock' => 'required',
            'category' => 'required',
            'brand' => 'required'
        ]);

        $product = Product::find($id);
        $product->name = $request->name;
        $product->description = $request->description;
        $product->price = $request->price;
        $product->stock = $request->stock;
        $product->category_id = $request->category;
        $product->brand_id = $request->brand;
        $product->save();

        return redirect()->route('products.show', $id)
            ->with('success', 'Product ' . $product->name . ' Successfully Updated');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $product = Product::find($id);
        $product->delete();

        return redirect()->route('products.index')
            ->with('error', 'Product ' . $product->name . ' has been removed');
    }
}

resources/views/products/create.blade.php
@extends('layouts.app')

@section('content')
    <form method="POST" action="{{ route('products.store') }}">
        <div class="card mx-auto" style="width: 30rem">
            <div class="card-header">
                Add Product
            </div>
            @include('products.form')
        </div>
    </form>
@endsection

resources/views/products/edit.blade.php
@extends('layouts.app')

@section('content')
    <form method="POST" action="{{ route('products.update', $product->id) }}">
        <input type="hidden" name="_method" value="PUT">
        <div class="card mx-auto" style="width: 30rem">
            <div class="card-header">
                Update Product
            </div>
            @include('products.form')
        </div>
    </form>
@endsection

resources/views/products/form.blade.php
@csrf
<div class="card-body">
    <div class="form-group">
        <label for="name">Name</label>
        <input type="text" class="form-control" id="name" name="name" value="{{ $product->name ?? '' }}"
            placeholder="Product Name">
    </div>
    <div class="form-group">
        <label for="description">Description</label>
        <textarea class="form-control" id="description" name="description"
            placeholder="Product Description">{{ $product->description ?? '' }}</textarea>
    </div>
    <div class="row">
        <div class="col-sm-6">
            <div class="form-group">
                <label for="price">Price</label>
                <input type="number" class="form-control" id="price" name="price" min="1"
                    value="{{ $product->price ?? '' }}" placeholder="₱ 0.00">
            </div>
        </div>
        <div class="form-group">
            <label for="stock">Stock</label>
            <input type="number" class="form-control" id="stock" name="stock" min="0"
                value="{{ $product->stock ?? '' }}" placeholder="0">
        </div>
        <div class="form-group col-sm-6">
            <label for="category">Category</label>
            <select name="category" id="category" class="form-control">
                <option value=>Select One</option>
                @foreach ($categories as $category)
                    <option value="{{ $category->id }}">{{ $category->name }}</option>
                @endforeach
            </select>
        </div>
        <div class="form-group">
            <label for="brand">Brand</label>
            <select name="brand" id="brand" style="width: 12rem" class="form-control">
                <option value=>Select One</option>
                @foreach ($brands as $brand)
                    <option value="{{ $brand->id }}">{{ $brand->name }}</option>
                @endforeach
            </select>
        </div>
    </div>
    <a class="btn btn-primary" href="{{ route('products.index') }}">Back</a>
    <input type="submit" value="Save" class="btn btn-success"
        onclick="this.disabled=true;this.value='Processing...';this.form.submit();">
</div>

resources/views/products/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <h1>List's of Product</h1>
        @unless(auth::guest())
            @if (auth::user()->role == 'seller')
                <a href="{{ route('products.create') }}" class="btn btn-primary"><b>+</b> Add Product</a> <br><br>
            @endif
        @endunless
        <div class="container">
            <form action="{{ route('products.index') }}" method="GET">
                <div class="form-group row">
                    <div class="col-md-1">
                        <label>Filter by Price:</label>
                    </div>
                    <label for="price_from">From:</label>
                    <div class="col-md-2">
                        <input type="number" class="form-control" name="price_from" id="price_from" min="1"
                            placeholder="₱ 0.00" value="{{ $price_from ?? '' }}">
                    </div><br><br>
                    <label for="price_to">To:</label>
                    <div class="col-md-2">
                        <input type="number" class="form-control" name="price_to" id="price_to" min="1" placeholder="₱ 0.00"
                            value="{{ $price_to ?? '' }}">
                    </div><br><br>
                    <label for="sort_brand">Filter by:</label>
                    <div class="col-md-2">
                        <select name="sort_brand" id="sort_brand" class="form-control">
                            @if (!$brand['name'] == '')
                                <option value="{{ $brand['id'] }}">--{{ $brand['name'] }}--</option>
                                <option value="">-----</option>
                            @else
                                <option value="">-----</option>
                            @endif
                            @foreach ($brands as $brand)
                                <option value="{{ $brand->id }}">{{ $brand->name }}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="col-md-2">
                        <input type="submit" class="btn btn-primary" value="Search">
                    </div>
                </div>
            </form>
        </div>
        @if (count($products) > 0)
            <div class="row">
                @foreach ($products as $product)
                    <div class="col-sm-4"> &nbsp;
                        <div class="card mx-auto">
                            <img class="card-img-top" src="D:\Al Wilson\Trabaho\I-Stor\gallery_icon.png"
                                alt="Card image cap">
                            <div class="card-body">
                                <h3 class="card-title">{{ $product->name }}</h3>
                                <p class="card-text">{{ $product->description }}</p>
                                <small>Price: ₱{{ $product->price }}</small> |
                                <small>Stock:{{ $product->stock }}</small> <br>
                                <small>Category:{{ $product->category->name }}</small> <br>
                                <small>Brand:{{ $product->brand->name }}</small> <br>
                                <small>Selller:{{ $product->user->name }}</small>
                                <a href="{{ route('products.show', $product->id) }}"
                                    class="btn btn-primary float-right">View</a>
                            </div>
                        </div>
                    </div>
                @endforeach
            </div> <br>
            {{ $products->links() }}
        @else
            <p> Product is Empty </p>
        @endif
    </div>
@endsection

resources/views/products/show.blade.php
@extends('layouts.app')

@section('content')
    <div class="card mx-auto" style="width: 30rem">
        <div class="card-header">
            {{ $product->name }}
        </div>
        <div class="card-body">
            <p>{{ $product->description }}</p>
            <small>Price: ₱{{ $product->price }}</small> |
            <small>Stock: {{ $product->stock }}</small> <br>
            <small>Category:{{ $product->category->name }}</small> <br>
            <small>Brand:{{ $product->brand->name }}</small> <br>
            <small>Seller:{{ $product->user->name }}</small> <br>
            <div class="mx-auto row">
                <a class="btn btn-primary" href="{{ route('products.index') }}">Back</a>
                <div class="col-md-10">
                    @unless(auth::guest())
                        @if (auth()->user()->id == $product->user->id)
                            <form action="{{ route('products.destroy', $product->id) }}" method="POST">
                                @csrf
                                <input type="hidden" name="_method" value="DELETE">
                                <div class="float-right">
                                    <a class="btn btn-primary" href="{{ route('products.edit', $product->id) }}">Update</a>
                                    <input class="btn btn-danger" type="submit" value="Delete">
                                </div>
                            </form>
                        @endif
                    @endunless
                    @unless(auth::guest())
                        @if (auth()->user()->role == 'user')
                            <form method="POST" action="{{ route('orders.store') }}">
                                @csrf
                                <input type="hidden" name="product_id" id="product_id" value="{{ $product->id }}">
                                <div class="float-right">
                                    <input type="submit" value="Order Now" class="btn btn-success"
                                        onclick="this.disabled=true;this.value='Processing...';this.form.submit();">
                                </div>
                                <div class="float-right">
                                    <input style="width: 5em" type="number" class="form-control" id="count" name="count" min="0"
                                        placeholder="0">
                                </div>
                                <label class="float-right" for="count">Count:</label>
                            </form>
                        @endif
                    @endunless
                </div>
            </div>
        </div>
    </div>
@endsection